/* AbstractBluetoothInterface.c generated by valac 0.48.19, the Vala compiler
 * generated from AbstractBluetoothInterface.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright 2022 Ubuntu Budgie Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: David Mohammed <fossfreedom@ubuntu.com>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define NETWORK_TYPE_WIDGET_NM_INTERFACE (network_widget_nm_interface_get_type ())
#define NETWORK_WIDGET_NM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_WIDGET_NM_INTERFACE, NetworkWidgetNMInterface))
#define NETWORK_WIDGET_NM_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_WIDGET_NM_INTERFACE, NetworkWidgetNMInterfaceClass))
#define NETWORK_IS_WIDGET_NM_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_WIDGET_NM_INTERFACE))
#define NETWORK_IS_WIDGET_NM_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_WIDGET_NM_INTERFACE))
#define NETWORK_WIDGET_NM_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_WIDGET_NM_INTERFACE, NetworkWidgetNMInterfaceClass))

typedef struct _NetworkWidgetNMInterface NetworkWidgetNMInterface;
typedef struct _NetworkWidgetNMInterfaceClass NetworkWidgetNMInterfaceClass;
typedef struct _NetworkWidgetNMInterfacePrivate NetworkWidgetNMInterfacePrivate;

#define NETWORK_TYPE_ABSTRACT_BLUETOOTH_INTERFACE (network_abstract_bluetooth_interface_get_type ())
#define NETWORK_ABSTRACT_BLUETOOTH_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_ABSTRACT_BLUETOOTH_INTERFACE, NetworkAbstractBluetoothInterface))
#define NETWORK_ABSTRACT_BLUETOOTH_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_ABSTRACT_BLUETOOTH_INTERFACE, NetworkAbstractBluetoothInterfaceClass))
#define NETWORK_IS_ABSTRACT_BLUETOOTH_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_ABSTRACT_BLUETOOTH_INTERFACE))
#define NETWORK_IS_ABSTRACT_BLUETOOTH_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_ABSTRACT_BLUETOOTH_INTERFACE))
#define NETWORK_ABSTRACT_BLUETOOTH_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_ABSTRACT_BLUETOOTH_INTERFACE, NetworkAbstractBluetoothInterfaceClass))

typedef struct _NetworkAbstractBluetoothInterface NetworkAbstractBluetoothInterface;
typedef struct _NetworkAbstractBluetoothInterfaceClass NetworkAbstractBluetoothInterfaceClass;
typedef struct _NetworkAbstractBluetoothInterfacePrivate NetworkAbstractBluetoothInterfacePrivate;
enum  {
	NETWORK_ABSTRACT_BLUETOOTH_INTERFACE_0_PROPERTY,
	NETWORK_ABSTRACT_BLUETOOTH_INTERFACE_NUM_PROPERTIES
};
static GParamSpec* network_abstract_bluetooth_interface_properties[NETWORK_ABSTRACT_BLUETOOTH_INTERFACE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NetworkWidgetNMInterface {
	GtkBox parent_instance;
	NetworkWidgetNMInterfacePrivate * priv;
	NMDevice* device;
};

struct _NetworkWidgetNMInterfaceClass {
	GtkBoxClass parent_class;
	void (*update) (NetworkWidgetNMInterface* self);
	void (*update_name) (NetworkWidgetNMInterface* self, gint count);
};

struct _NetworkAbstractBluetoothInterface {
	NetworkWidgetNMInterface parent_instance;
	NetworkAbstractBluetoothInterfacePrivate * priv;
};

struct _NetworkAbstractBluetoothInterfaceClass {
	NetworkWidgetNMInterfaceClass parent_class;
};

static gpointer network_abstract_bluetooth_interface_parent_class = NULL;
static GType network_abstract_bluetooth_interface_type_id = 0;

GType network_widget_nm_interface_register_type (GTypeModule * module);
GType network_widget_nm_interface_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkWidgetNMInterface, g_object_unref)
GType network_abstract_bluetooth_interface_register_type (GTypeModule * module);
GType network_abstract_bluetooth_interface_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NetworkAbstractBluetoothInterface, g_object_unref)
void network_widget_nm_interface_update_name (NetworkWidgetNMInterface* self,
                                              gint count);
static void network_abstract_bluetooth_interface_real_update_name (NetworkWidgetNMInterface* base,
                                                            gint count);
void network_widget_nm_interface_set_display_title (NetworkWidgetNMInterface* self,
                                                    const gchar* value);
NetworkAbstractBluetoothInterface* network_abstract_bluetooth_interface_construct (GType object_type);
NetworkWidgetNMInterface* network_widget_nm_interface_construct (GType object_type);

static void
network_abstract_bluetooth_interface_real_update_name (NetworkWidgetNMInterface* base,
                                                       gint count)
{
	NetworkAbstractBluetoothInterface * self;
	gchar* name = NULL;
	NMDevice* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	self = (NetworkAbstractBluetoothInterface*) base;
	_tmp0_ = ((NetworkWidgetNMInterface*) self)->device;
	_tmp1_ = nm_device_get_description (_tmp0_);
	_tmp2_ = g_strdup (_tmp1_);
	name = _tmp2_;
	_tmp3_ = g_strdup_printf (_ ("%s Network"), name);
	_tmp4_ = _tmp3_;
	network_widget_nm_interface_set_display_title ((NetworkWidgetNMInterface*) self, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (name);
}

NetworkAbstractBluetoothInterface*
network_abstract_bluetooth_interface_construct (GType object_type)
{
	NetworkAbstractBluetoothInterface * self = NULL;
	self = (NetworkAbstractBluetoothInterface*) network_widget_nm_interface_construct (object_type);
	return self;
}

static void
network_abstract_bluetooth_interface_class_init (NetworkAbstractBluetoothInterfaceClass * klass,
                                                 gpointer klass_data)
{
	network_abstract_bluetooth_interface_parent_class = g_type_class_peek_parent (klass);
	((NetworkWidgetNMInterfaceClass *) klass)->update_name = (void (*) (NetworkWidgetNMInterface*, gint)) network_abstract_bluetooth_interface_real_update_name;
}

static void
network_abstract_bluetooth_interface_instance_init (NetworkAbstractBluetoothInterface * self,
                                                    gpointer klass)
{
}

GType
network_abstract_bluetooth_interface_get_type (void)
{
	return network_abstract_bluetooth_interface_type_id;
}

GType
network_abstract_bluetooth_interface_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkAbstractBluetoothInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_abstract_bluetooth_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkAbstractBluetoothInterface), 0, (GInstanceInitFunc) network_abstract_bluetooth_interface_instance_init, NULL };
	network_abstract_bluetooth_interface_type_id = g_type_module_register_type (module, NETWORK_TYPE_WIDGET_NM_INTERFACE, "NetworkAbstractBluetoothInterface", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return network_abstract_bluetooth_interface_type_id;
}

